/*
$Source: w:/cvsroot/webarts/widgets/ImageCanvas.java,v $
$Name:  $

$Revision: 1.3 $
$Date: 2001/10/28 06:46:07 $
$Locker:  $
*/

/* This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
package ca.bc.webarts.widgets;

import java.awt.Canvas;
import java.awt.Dimension;
import java.awt.Graphics;
import java.awt.Image;
import java.awt.MediaTracker;

/**
 *  A simple canvas for painting an Image in its center.
 *
 * @author     unknown
 * @created    October 27, 2001
 */
public class ImageCanvas extends Canvas
{
  /**
   *  The Image to Paint.
   *
   * @since
   */
  private Image          image_;
  /**
   *  Class holder for the image height.
   *
   * @since
   */
  private int            imageHeight = 0;
  /**
   *  Class holder for the image width.
   *
   * @since
   */
  private int            imageWidth = 0;


  /**
   *  Constructor for the ImageCanvas object.
   *
   * @param  image  The Image to paint.
   * @since
   */
  public ImageCanvas(Image image)
  {
    image_ = image;
    imageHeight = image_.getHeight(this);
    imageWidth = image_.getWidth(this);
    MediaTracker mt = new MediaTracker(this);
    mt.addImage(image_, 0);

    try
    {
      mt.waitForID(0);
    }
    catch (Exception e)
    {
      e.printStackTrace();
    }
  }


  /**
   *  Gets the PreferredSize attribute of the ImageCanvas object.
   *
   * @return    The PreferredSize value
   * @since
   */
  public Dimension getPreferredSize()
  {
    return new Dimension(imageWidth,
        imageHeight);
  }


  /**
   *  Over rides the Paint method to paint our image
   *
   * @param  g  Description of Parameter
   * @since
   */
  public void paint(Graphics g)
  {
    g.drawImage(image_,
        (getWidth() - imageWidth) / 2,
        (getHeight() - imageHeight) / 2,
        this);
  }


  /**
   *  Simply calls paint(g).
   *
   * @param  g  The graphics object to paint into.
   * @since
   */
  public void update(Graphics g)
  {
    paint(g);
  }
}




